# bio-conduit
#
# Copyright (C) 2015
#
# author: Natapol Pornputtapong <natapol.por@gmail.com>
#
# Documentation: Natapol Pornputtapong (RDoc'd and embellished by William Webber)
#
module Bio
    module Conduit
        class Samples

            attr_reader :samples, :resources, :groups

            def initialize(filename)
                yaml = YAML::load(File.open(filename))

                @samples = {}
                @groups = {}

                if yaml.has_key?("resources")
                    @resources = yaml["resources"]
                else
                    @resources = {}
                end

                if yaml.has_key?("samples")
                    yaml["samples"].each_pair do |l1k, l1v|
                        if l1v.is_a?(Hash)
                            l1v.each_pair do |k, v|
                                @samples[k] = {}
                                @samples[k]['name'] = k
                                @samples[k]['path'] = v
                                @samples[k]["resources"] = @resources
                                @samples[k]["group"] = l1k
                                @groups[l1k] ||= []
                                @groups[l1k].push(@samples[k])
                            end
                        else
                            @samples[l1k] = {}
                            @samples[l1k]['name'] = l1k
                            @samples[l1k]['path'] = l1v
                            @samples[l1k]["resources"] = @resources
                        end
                    end
                end

            end

            def [](name)
                @samples[name]
            end

            def each(&block)
                @samples.each do |sam|
                    block.call(sam)
                end
            end
        end
    end
end
